#include "cps.h"

/*========================================================
 Battle Circuit
========================================================*/

static struct BurnInputInfo DrvInputList[] =
{
 {"P1 Coin"       , BIT_DIGITAL, CpsInp020+4, "p1 coin"  },
 {"P1 Start"      , BIT_DIGITAL, CpsInp020+0, "p1 start" },
 {"P1 Up"         , BIT_DIGITAL, CpsInp001+3, "p1 up"    },
 {"P1 Down"       , BIT_DIGITAL, CpsInp001+2, "p1 down"  },
 {"P1 Left"       , BIT_DIGITAL, CpsInp001+1, "p1 left"  },
 {"P1 Right"      , BIT_DIGITAL, CpsInp001+0, "p1 right" },
 {"P1 Attack"     , BIT_DIGITAL, CpsInp001+4, "p1 fire 1"},
 {"P1 Jump"       , BIT_DIGITAL, CpsInp001+5, "p1 fire 2"},

 {"P2 Coin"       , BIT_DIGITAL, CpsInp020+5, "p2 coin"  },
 {"P2 Start"      , BIT_DIGITAL, CpsInp020+1, "p2 start" },
 {"P2 Up"         , BIT_DIGITAL, CpsInp000+3, "p2 up"    },
 {"P2 Down"       , BIT_DIGITAL, CpsInp000+2, "p2 down"  },
 {"P2 Left"       , BIT_DIGITAL, CpsInp000+1, "p2 left"  },
 {"P2 Right"      , BIT_DIGITAL, CpsInp000+0, "p2 right" },
 {"P2 Attack"     , BIT_DIGITAL, CpsInp000+4, "p2 fire 1"},
 {"P2 Jump"       , BIT_DIGITAL, CpsInp000+5, "p2 fire 2"},

 {"P3 Coin"       , BIT_DIGITAL, CpsInp020+6, "p3 coin"  },
 {"P3 Start"      , BIT_DIGITAL, CpsInp020+2, "p3 start" },
 {"P3 Up"         , BIT_DIGITAL, CpsInp011+3, "p3 up"    },
 {"P3 Down"       , BIT_DIGITAL, CpsInp011+2, "p3 down"  },
 {"P3 Left"       , BIT_DIGITAL, CpsInp011+1, "p3 left"  },
 {"P3 Right"      , BIT_DIGITAL, CpsInp011+0, "p3 right" },
 {"P3 Attack"     , BIT_DIGITAL, CpsInp011+4, "p3 fire 1"},
 {"P3 Jump"       , BIT_DIGITAL, CpsInp011+5, "p3 fire 2"},

 {"P4 Coin"       , BIT_DIGITAL, CpsInp020+7, "p4 coin"  },
 {"P4 Start"      , BIT_DIGITAL, CpsInp020+3, "p4 start" },
 {"P4 Up"         , BIT_DIGITAL, CpsInp010+3, "p4 up"    },
 {"P4 Down"       , BIT_DIGITAL, CpsInp010+2, "p4 down"  },
 {"P4 Left"       , BIT_DIGITAL, CpsInp010+1, "p4 left"  },
 {"P4 Right"      , BIT_DIGITAL, CpsInp010+0, "p4 right" },
 {"P4 Attack"     , BIT_DIGITAL, CpsInp010+4, "p4 fire 1"},
 {"P4 Jump"       , BIT_DIGITAL, CpsInp010+5, "p4 fire 2"},

 {"Reset"         , BIT_DIGITAL, &CpsReset,   "reset"    },
 {"Diagnostic"    , BIT_DIGITAL, CpsInp021+1, "diag"     },
 {"Service"       , BIT_DIGITAL, CpsInp021+2, "service"  },
};

STDINPUTINFO(Drv);

/*======================
 Battle Circuit (Japan)
======================*/


static struct BurnRomInfo BatcirjRomDesc[]=
{
 {"btcjx.03",0x80000,0x01482d08, 0x10},
 {"btcjx.04",0x80000,0x3d4c976b, 0x10},
 {"btcjx.05",0x80000,0x5bf819e1, 0x10},
 {"btcjx.06",0x80000,0x5d2fd190, 0x10},

 {"btcj.03" ,0x80000,0x6b7e168d, 0x10},
 {"btcj.04" ,0x80000,0x46ba3467, 0x10},
 {"btcj.05" ,0x80000,0x0e23a859, 0x10},
 {"btcj.06" ,0x80000,0xa853b59c, 0x10},
 {"btc.07"  ,0x80000,0x7322d5db, 0x10},
 {"btc.08"  ,0x80000,0x6aac85ab, 0x10},
 {"btc.09"  ,0x80000,0x1203db08, 0x10},

 {"btc.13" ,0x400000,0xdc705bad,    1},
 {"btc.15" ,0x400000,0xe5779a3c,    1},
 {"btc.17" ,0x400000,0xb33f4112,    1},
 {"btc.19" ,0x400000,0xa6fcdb7e,    1},

 {"btc.01" ,0x020000,0x1e194310,    2},
 {"btc.02" ,0x020000,0x01aeb8e6,    2},

 {"btc.11" ,0x200000,0xc27f2229,    2},
 {"btc.12" ,0x200000,0x418a2e33,    2},
};

STD_ROM_PICK(Batcirj) STD_ROM_FN(Batcirj)

struct BurnDriver BurnDrvCpsBatcirj=
{
 {"batcirj" ,"Battle Circuit (Japan 970319)",NULL,"Capcom","CPS2","1997","batcir", NULL},
 BDF_GAME_WORKING | BDF_CLONE,4,HARDWARE_CAPCOM_CPS2,
 NULL, BatcirjRomInfo, BatcirjRomName, DrvInputInfo, NULL,
 Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
 &CpsRecalcPal,384,224,4,3
};

/*===============================
 Battle Circuit (Asia) Encrypted
===============================*/


static struct BurnRomInfo BatciraRomDesc[]=
{
// {"btcax.03",0x80000,0x00000000, 0x10},
// {"btcax.04",0x80000,0x00000000, 0x10},
// {"btcax.05",0x80000,0x00000000, 0x10},
// {"btcax.06",0x80000,0x00000000, 0x10},

 {"btca.03" ,0x80000,0x1ad20d87, 0x10},
 {"btca.04" ,0x80000,0x2b3f4dbe, 0x10},
 {"btca.05" ,0x80000,0x8238a3d9, 0x10},
 {"btca.06" ,0x80000,0x446c7c02, 0x10},
 {"btc.07"  ,0x80000,0x7322d5db, 0x10},
 {"btc.08"  ,0x80000,0x6aac85ab, 0x10},
 {"btc.09"  ,0x80000,0x1203db08, 0x10},

 {"btc.13" ,0x400000,0xdc705bad,    1},
 {"btc.15" ,0x400000,0xe5779a3c,    1},
 {"btc.17" ,0x400000,0xb33f4112,    1},
 {"btc.19" ,0x400000,0xa6fcdb7e,    1},

 {"btc.01" ,0x020000,0x1e194310,    2},
 {"btc.02" ,0x020000,0x01aeb8e6,    2},

 {"btc.11" ,0x200000,0xc27f2229,    2},
 {"btc.12" ,0x200000,0x418a2e33,    2},
};

STD_ROM_PICK(Batcira) STD_ROM_FN(Batcira)

struct BurnDriver BurnDrvCpsBatcira=
{
 {"batcira" ,"Battle Circuit (Asia 970319)","Encrypted","Capcom","CPS2","1997","batcir", NULL},
 BDF_CLONE,4,HARDWARE_CAPCOM_CPS2,
 NULL, BatciraRomInfo, BatciraRomName, DrvInputInfo, NULL,
 Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
 &CpsRecalcPal,384,224,4,3
};

/*===============================
 Battle Circuit (Euro)
===============================*/


static struct BurnRomInfo BatcirRomDesc[]=
{
 {"btcex.03",0x80000,0x2d193cd0, 0x10},
 {"btcex.04",0x80000,0xa3895d8b, 0x10},
 {"btcex.05",0x80000,0xbdbed16f, 0x10},
 {"btcex.06",0x80000,0x02048217, 0x10},

 {"btce.03" ,0x80000,0xbc60484b, 0x10},
 {"btce.04" ,0x80000,0x457d55f6, 0x10},
 {"btce.05" ,0x80000,0xe86560d7, 0x10},
 {"btce.06" ,0x80000,0xf778e61b, 0x10},
 {"btc.07"  ,0x80000,0x7322d5db, 0x10},
 {"btc.08"  ,0x80000,0x6aac85ab, 0x10},
 {"btc.09"  ,0x80000,0x1203db08, 0x10},

 {"btc.13" ,0x400000,0xdc705bad,    1},
 {"btc.15" ,0x400000,0xe5779a3c,    1},
 {"btc.17" ,0x400000,0xb33f4112,    1},
 {"btc.19" ,0x400000,0xa6fcdb7e,    1},

 {"btc.01" ,0x020000,0x1e194310,    2},
 {"btc.02" ,0x020000,0x01aeb8e6,    2},

 {"btc.11" ,0x200000,0xc27f2229,    2},
 {"btc.12" ,0x200000,0x418a2e33,    2},
};

STD_ROM_PICK(Batcir) STD_ROM_FN(Batcir)

struct BurnDriver BurnDrvCpsBatcir=
{
 {"batcir" ,"Battle Circuit (Euro 970319)",NULL,"Capcom","CPS2","1997",NULL, NULL},
 BDF_GAME_WORKING,4,HARDWARE_CAPCOM_CPS2,
 NULL, BatcirRomInfo, BatcirRomName, DrvInputInfo, NULL,
 Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
 &CpsRecalcPal,384,224,4,3
};
