#include "cps.h"

/*==================================
 D&D:TOD
==================================*/


static struct BurnInputInfo DrvInputList[] =
{
  {"P1 Coin"       , BIT_DIGITAL, CpsInp020+4, "p1 coin"  },
  {"P1 Start"      , BIT_DIGITAL, CpsInp020+0, "p1 start" },
  {"P1 Up"         , BIT_DIGITAL, CpsInp001+3, "p1 up"    },
  {"P1 Down"       , BIT_DIGITAL, CpsInp001+2, "p1 down"  },
  {"P1 Left"       , BIT_DIGITAL, CpsInp001+1, "p1 left"  },
  {"P1 Right"      , BIT_DIGITAL, CpsInp001+0, "p1 right" },
  {"P1 Attack"     , BIT_DIGITAL, CpsInp001+4, "p1 fire 1"},
  {"P1 Jump"       , BIT_DIGITAL, CpsInp001+5, "p1 fire 2"},
  {"P1 Use"        , BIT_DIGITAL, CpsInp001+6, "p1 fire 3"},
  {"P1 Select"     , BIT_DIGITAL, CpsInp001+7, "p1 fire 4"},

  {"P2 Coin"       , BIT_DIGITAL, CpsInp020+5, "p2 coin"  },
  {"P2 Start"      , BIT_DIGITAL, CpsInp020+1, "p2 start" },
  {"P2 Up"         , BIT_DIGITAL, CpsInp000+3, "p2 up"    },
  {"P2 Down"       , BIT_DIGITAL, CpsInp000+2, "p2 down"  },
  {"P2 Left"       , BIT_DIGITAL, CpsInp000+1, "p2 left"  },
  {"P2 Right"      , BIT_DIGITAL, CpsInp000+0, "p2 right" },
  {"P2 Attack"     , BIT_DIGITAL, CpsInp000+4, "p2 fire 1"},
  {"P2 Jump"       , BIT_DIGITAL, CpsInp000+5, "p2 fire 2"},
  {"P2 Use"        , BIT_DIGITAL, CpsInp000+6, "p2 fire 3"},
  {"P2 Select"     , BIT_DIGITAL, CpsInp000+7, "p2 fire 4"},

  {"P3 Coin"       , BIT_DIGITAL, CpsInp020+6, "p3 coin"  },
  {"P3 Start"      , BIT_DIGITAL, CpsInp020+2, "p3 start" },
  {"P3 Up"         , BIT_DIGITAL, CpsInp011+3, "p3 up"    },
  {"P3 Down"       , BIT_DIGITAL, CpsInp011+2, "p3 down"  },
  {"P3 Left"       , BIT_DIGITAL, CpsInp011+1, "p3 left"  },
  {"P3 Right"      , BIT_DIGITAL, CpsInp011+0, "p3 right" },
  {"P3 Attack"     , BIT_DIGITAL, CpsInp011+4, "p3 fire 1"},
  {"P3 Jump"       , BIT_DIGITAL, CpsInp011+5, "p3 fire 2"},
  {"P3 Use"        , BIT_DIGITAL, CpsInp011+6, "p3 fire 3"},
  {"P3 Select"     , BIT_DIGITAL, CpsInp011+7, "p3 fire 4"},

  {"P4 Coin"       , BIT_DIGITAL, CpsInp020+7, "p4 coin"  },
  {"P4 Start"      , BIT_DIGITAL, CpsInp020+3, "p4 start" },
  {"P4 Up"         , BIT_DIGITAL, CpsInp010+3, "p4 up"    },
  {"P4 Down"       , BIT_DIGITAL, CpsInp010+2, "p4 down"  },
  {"P4 Left"       , BIT_DIGITAL, CpsInp010+1, "p4 left"  },
  {"P4 Right"      , BIT_DIGITAL, CpsInp010+0, "p4 right" },
  {"P4 Attack"     , BIT_DIGITAL, CpsInp010+4, "p4 fire 1"},
  {"P4 Jump"       , BIT_DIGITAL, CpsInp010+5, "p4 fire 2"},
  {"P4 Use"        , BIT_DIGITAL, CpsInp010+6, "p4 fire 3"},
  {"P4 Select"     , BIT_DIGITAL, CpsInp010+7, "p4 fire 4"},

  {"Reset"         , BIT_DIGITAL, &CpsReset,   "reset"    },
  {"Diagnostic"    , BIT_DIGITAL, CpsInp021+1, "diag"     },
  {"Service"       , BIT_DIGITAL, CpsInp021+2, "service"  },
};

STDINPUTINFO(Drv);

/*========================
 D&D: Tower of Doom (Euro)
========================*/


static struct BurnRomInfo DdtodRomDesc[]=
{
  {"dadex.03c",0x80000,0x7b8b9b2c, 0x10}, // xor decryption tables
  {"dadex.04c",0x80000,0x370626d3, 0x10},
  {"dadex.05c",0x80000,0x5fd29e95, 0x10},

  {"dade.03c" ,0x80000,0x8e73533d, 0x10}, // 68000 code (encrypted)
  {"dade.04c" ,0x80000,0x00c2e82e, 0x10},
  {"dade.05c" ,0x80000,0xea996008, 0x10},
  {"dade.06a" ,0x80000,0x6225495a, 0x10},
  {"dade.07a" ,0x80000,0xb3480ec3, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtod) STD_ROM_FN(Ddtod)

struct BurnDriver BurnDrvCpsDdtod=
{
  {"ddtod" ,"Dungeons & Dragons: Tower of Doom (Euro 940412)",NULL,"Capcom","CPS2","1994",NULL, NULL},
  BDF_GAME_WORKING, 4, HARDWARE_CAPCOM_CPS2,
  NULL, DdtodRomInfo, DdtodRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*========================
 D&D: Tower of Doom (USA)
========================*/


static struct BurnRomInfo DdtoduRomDesc[]=
{
  {"dadux.03b",0x80000,0xf59ee70c, 0x10}, // xor decryption tables
  {"dadux.04b",0x80000,0x622628ae, 0x10},
  {"dadux.05b",0x80000,0x424bd6e3, 0x10},

  {"dadu.03b" ,0x80000,0xa519905f, 0x10}, // 68000 code (encrypted)
  {"dadu.04b" ,0x80000,0x52562d38, 0x10},
  {"dadu.05b" ,0x80000,0xee1cfbfe, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtodu) STD_ROM_FN(Ddtodu)

struct BurnDriver BurnDrvCpsDdtodu=
{
  {"ddtodu" ,"Dungeons & Dragons: Tower of Doom (US 940125)",NULL,"Capcom","CPS2","1994","ddtod", NULL},
  BDF_GAME_WORKING | BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, DdtoduRomInfo, DdtoduRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*===========================
 D&D: Tower of Doom (USA r1)
===========================*/


static struct BurnRomInfo Ddtodur1RomDesc[]=
{
  {"dadux.03a",0x80000,0xf9ba14b6, 0x10}, // xor decryption tables
  {"dadux.04a",0x80000,0xed85ec29, 0x10},
  {"dadux.05a",0x80000,0xdbae3d1b, 0x10},

  {"dadu.03a" ,0x80000,0x4413f177, 0x10}, // 68000 code (encrypted)
  {"dadu.04a" ,0x80000,0x168de230, 0x10},
  {"dadu.05a" ,0x80000,0x03d39e91, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtodur1) STD_ROM_FN(Ddtodur1)

struct BurnDriver BurnDrvCpsDdtodur1=
{
  {"ddtodur1" ,"Dungeons & Dragons: Tower of Doom (US 940113)",NULL,"Capcom","CPS2","1994","ddtod", NULL},
  BDF_GAME_WORKING | BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, Ddtodur1RomInfo, Ddtodur1RomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*==========================
 D&D: Tower of Doom (Japan)
==========================*/


static struct BurnRomInfo DdtodjRomDesc[]=
{
  {"dadjx.03b",0x80000,0x590f7591, 0x10}, // xor decryption tables
  {"dadjx.04b",0x80000,0x3735c834, 0x10},
  {"dadjx.05b",0x80000,0xb0a2a913, 0x10},

  {"dadj.03b" ,0x80000,0x87606b85, 0x10}, // 68000 code (encrypted)
  {"dadj.04b" ,0x80000,0x24d49575, 0x10},
  {"dadj.05b" ,0x80000,0x56ce51f7, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtodj) STD_ROM_FN(Ddtodj)

struct BurnDriver BurnDrvCpsDdtodj=
{
  {"ddtodj" ,"Dungeons & Dragons: Tower of Doom (Japan 940125)",NULL,"Capcom","CPS2","1994","ddtod", NULL},
  BDF_GAME_WORKING | BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, DdtodjRomInfo, DdtodjRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*==========================
 D&D: Tower of Doom (Japan) R1
==========================*/


static struct BurnRomInfo Ddtodjr1RomDesc[]=
{
  {"dadjx.03a",0x80000,0x4c7334d3, 0x10}, // xor decryption tables
  {"dadjx.04a",0x80000,0xcfd15109, 0x10},
  {"dadjx.05a",0x80000,0xd23bcd71, 0x10},

  {"dadj.03a" ,0x80000,0x711638dc, 0x10}, // 68000 code (encrypted)
  {"dadj.04a" ,0x80000,0x4869639c, 0x10},
  {"dadj.05a" ,0x80000,0x484c0efa, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtodjr1) STD_ROM_FN(Ddtodjr1)

struct BurnDriver BurnDrvCpsDdtodjr1=
{
  {"ddtodjr1" ,"Dungeons & Dragons: Tower of Doom (Japan 940113)",NULL,"Capcom","CPS2","1994","ddtod", NULL},
  BDF_GAME_WORKING | BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, Ddtodjr1RomInfo, Ddtodjr1RomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*===================================
 D&D: Tower of Doom (Asia) Encrypted
===================================*/


static struct BurnRomInfo DdtodaRomDesc[]=
{
//  {"dadax.03a",0x80000,0x00000000, 0x10}, // xor decryption tables
//  {"dadax.04a",0x80000,0x00000000, 0x10},
//  {"dadax.05a",0x80000,0x00000000, 0x10},

  {"dada.03a" ,0x80000,0xfc6f2dd7, 0x10}, // 68000 code (encrypted)
  {"dada.04a" ,0x80000,0xd4be4009, 0x10},
  {"dada.05a" ,0x80000,0x6712d1cf, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtoda) STD_ROM_FN(Ddtoda)

struct BurnDriver BurnDrvCpsDdtoda=
{
  {"ddtoda" ,"Dungeons & Dragons: Tower of Doom (Asia 940113)","Encrypted","Capcom","CPS2","1994","ddtod", NULL},
  BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, DdtodaRomInfo, DdtodaRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*============================
 D&D: Tower of Doom (Hispanic)
============================*/


static struct BurnRomInfo DdtodhRomDesc[]=
{
  {"dadhx.03b",0x80000,0xb9a16065, 0x10}, // xor decryption tables
  {"dadhx.04b",0x80000,0x6b0d5086, 0x10},
  {"dadhx.05b",0x80000,0xe01ee2b2, 0x10},

  {"dadh.03b" ,0x80000,0xae0cb98e, 0x10}, // 68000 code (encrypted)
  {"dadh.04b" ,0x80000,0xb5774363, 0x10},
  {"dadh.05b" ,0x80000,0x6ce2a485, 0x10},
  {"dad.06"   ,0x80000,0x13aa3e56, 0x10},
  {"dad.07"   ,0x80000,0x431cb6dd, 0x10},

  // graphics:
  {"dad.13"  ,0x200000,0xda3cb7d6,    1}, // 8
  {"dad.15"  ,0x200000,0x92b63172,    1},
  {"dad.17"  ,0x200000,0xb98757f5,    1},
  {"dad.19"  ,0x200000,0x8121ce46,    1},
  {"dad.14"  ,0x100000,0x837e6f3f,    1},
  {"dad.16"  ,0x100000,0xf0916bdb,    1},
  {"dad.18"  ,0x100000,0xcef393ef,    1},
  {"dad.20"  ,0x100000,0x8953fe9e,    1},

  // sound - z80 roms
  {"dad.01"  ,0x020000,0x3f5e2424,    2}, // 16
  // sound - samples
  {"dad.11"  ,0x200000,0x0c499b67,    2},
  {"dad.12"  ,0x200000,0x2f0b5a4e,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Ddtodh) STD_ROM_FN(Ddtodh)

struct BurnDriver BurnDrvCpsDdtodh=
{
  {"ddtodh" ,"Dungeons & Dragons: Tower of Doom (Hispanic 940125)",NULL,"Capcom","CPS2","1994","ddtod", NULL},
  BDF_GAME_WORKING | BDF_CLONE, 4, HARDWARE_CAPCOM_CPS2,
  NULL, DdtodhRomInfo, DdtodhRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
