#include "cps.h" 
#define BRF_PRG				(1 << 16)
#define BRF_GRA				(1 << 17)
#define BRF_SND				(1 << 18)

#define BRF_ESS				(1 << 24)
#define BRF_BIOS			(1 << 25)
#define BRF_SELECT			(1 << 26)
#define BRF_OPT				(1 << 27)

//============================================== 
// Progear no Arashi 
//============================================== 

static struct BurnInputInfo DrvInputList[] = 
{ 
{"P1 Coin" , BIT_DIGITAL, CpsInp020+4, "p1 coin"}, 
{"P1 Start" , BIT_DIGITAL, CpsInp020+0, "p1 start"}, 
{"P1 Up" , BIT_DIGITAL, CpsInp001+3, "p1 up"}, 
{"P1 Down" , BIT_DIGITAL, CpsInp001+2, "p1 down"}, 
{"P1 Left" , BIT_DIGITAL, CpsInp001+1, "p1 left"}, 
{"P1 Right" , BIT_DIGITAL, CpsInp001+0, "p1 right"}, 
{"P1 Shot" , BIT_DIGITAL, CpsInp001+4, "p1 fire 1"}, 
{"P1 Bomb" , BIT_DIGITAL, CpsInp001+5, "p1 fire 2"}, 

{"P2 Coin" , BIT_DIGITAL, CpsInp020+5, "p2 coin"}, 
{"P2 Start" , BIT_DIGITAL, CpsInp020+1, "p2 start"}, 
{"P2 Up" , BIT_DIGITAL, CpsInp000+3, "p2 up"}, 
{"P2 Down" , BIT_DIGITAL, CpsInp000+2, "p2 down"}, 
{"P2 Left" , BIT_DIGITAL, CpsInp000+1, "p2 left"}, 
{"P2 Right" , BIT_DIGITAL, CpsInp000+0, "p2 right"}, 
{"P2 Shot" , BIT_DIGITAL, CpsInp000+4, "p2 fire 1"}, 
{"P2 Bomb" , BIT_DIGITAL, CpsInp000+5, "p2 fire 2"}, 

{"Reset" , BIT_DIGITAL, &CpsReset , "reset"}, 
{"Diagnostic" , BIT_DIGITAL, CpsInp021+1, "diag"}, 
{"Service" , BIT_DIGITAL, CpsInp021+2, "service"}, 
}; 

STDINPUTINFO(Drv); 

//======================= 
// Progear no Arashi (USA) 
//======================== 

static struct BurnRomInfo ProgearRomDesc[]= 
{ 
{"pgaux.03" ,0x80000,0xfd58616b, 0x10}, 
{"pgaux.04" ,0x80000,0x6081a891, 0x10}, 

{"pgau.03" ,0x80000,0x343a783e, 0x10}, 
{"pgau.04" ,0x80000,0x16208d79, 0x10}, 

{"pga-sim.01c" ,0x200000,0x452f98b0, 1}, 
{"pga-sim.01d" ,0x200000,0x9e672092, 1}, 
{"pga-sim.01a" ,0x200000,0xae9ddafe, 1}, 
{"pga-sim.01b" ,0x200000,0x94d72d94, 1}, 
{"pga-sim.03c" ,0x200000,0x48a1886d, 1}, 
{"pga-sim.03d" ,0x200000,0x172d7e37, 1}, 
{"pga-sim.03a" ,0x200000,0x9ee33d98, 1}, 
{"pga-sim.03b" ,0x200000,0x848dee32, 1}, 

{"pga.01" ,0x020000,0xbdbfa992, 2}, 

{"pga-sim.05a" ,0x200000,0xc0aac80c, 2}, 
{"pga-sim.05b" ,0x200000,0x37a65d86, 2}, 
{"pga-sim.06a" ,0x200000,0xd3f1e934, 2}, 
{"pga-sim.06b" ,0x200000,0x8b39489a, 2},
};

STD_ROM_PICK(Progear) STD_ROM_FN(Progear) 

struct BurnDriver BurnDrvCpsProgear= 
{ 
{"progear" ,"Progear no Arashi (US 010117)", NULL,"Capcom / Cave","CPS2","2001",NULL, NULL}, 
BDF_GAME_WORKING, 2, HARDWARE_CAPCOM_CPS2 | HARDWARE_CAPCOM_CPS2_SIMM, 
NULL, ProgearRomInfo, ProgearRomName, DrvInputInfo, NULL, 
Cps2Init,CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan, 
&CpsRecalcPal,384,224,4,3 
}; 

//======================== 
// Progear no Arashi (Japan) 
//======================== 

static struct BurnRomInfo ProgearjRomDesc[]= 
{ 
{"pgajx.03" ,0x80000,0xb44e4bcf, 0x10}, 
{"pgajx.04" ,0x80000,0x354db29d, 0x10}, 

{"pgaj.03" ,0x80000,0x06dbba54, 0x10}, 
{"pgaj.04" ,0x80000,0xa1f1f1bc, 0x10}, 

{"pga-sim.01c" ,0x200000,0x452f98b0, 1}, 
{"pga-sim.01d" ,0x200000,0x9e672092, 1}, 
{"pga-sim.01a" ,0x200000,0xae9ddafe, 1}, 
{"pga-sim.01b" ,0x200000,0x94d72d94, 1}, 
{"pga-sim.03c" ,0x200000,0x48a1886d, 1}, 
{"pga-sim.03d" ,0x200000,0x172d7e37, 1}, 
{"pga-sim.03a" ,0x200000,0x9ee33d98, 1}, 
{"pga-sim.03b" ,0x200000,0x848dee32, 1}, 

{"pga.01" ,0x020000,0xbdbfa992, 2}, 

{"pga-sim.05a" ,0x200000,0xc0aac80c, 2}, 
{"pga-sim.05b" ,0x200000,0x37a65d86, 2}, 
{"pga-sim.06a" ,0x200000,0xd3f1e934, 2}, 
{"pga-sim.06b" ,0x200000,0x8b39489a, 2}, 
}; 

STD_ROM_PICK(Progearj) STD_ROM_FN(Progearj) 

struct BurnDriver BurnDrvCpsProgearj= 
{ 
{"progearj" ,"Progear no Arashi (Japan 010117)", NULL,"Capcom / Cave","CPS2","2001","progear", NULL}, 
BDF_GAME_WORKING | BDF_CLONE, 2, HARDWARE_CAPCOM_CPS2 | HARDWARE_CAPCOM_CPS2_SIMM, 
NULL, ProgearjRomInfo, ProgearjRomName, DrvInputInfo, NULL, 
Cps2Init,CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan, 
&CpsRecalcPal,384,224,4,3 
}; 

/*======================= 
Progear no Arashi (Asia) 
========================*/ 

static struct BurnRomInfo ProgearaRomDesc[]= 
{ 
{"pgaax.03" ,0x80000,0x00000000, 0x10}, 
{"pgaax.04" ,0x80000,0x00000000, 0x10}, 

{"pgaa.03" ,0x80000,0x25e6e2ce, 0x10}, 
{"pgaa.04" ,0x80000,0x8104307e, 0x10}, 

{"pga-sim.01c" ,0x200000,0x452f98b0, 1}, 
{"pga-sim.01d" ,0x200000,0x9e672092, 1}, 
{"pga-sim.01a" ,0x200000,0xae9ddafe, 1}, 
{"pga-sim.01b" ,0x200000,0x94d72d94, 1}, 
{"pga-sim.03c" ,0x200000,0x48a1886d, 1}, 
{"pga-sim.03d" ,0x200000,0x172d7e37, 1}, 
{"pga-sim.03a" ,0x200000,0x9ee33d98, 1}, 
{"pga-sim.03b" ,0x200000,0x848dee32, 1}, 

{"pga.01" ,0x020000,0xbdbfa992, 2}, 

{"pga-sim.05a" ,0x200000,0xc0aac80c, 2}, 
{"pga-sim.05b" ,0x200000,0x37a65d86, 2}, 
{"pga-sim.06a" ,0x200000,0xd3f1e934, 2}, 
{"pga-sim.06b" ,0x200000,0x8b39489a, 2}, 
}; 

STD_ROM_PICK(Progeara) STD_ROM_FN(Progeara) 

struct BurnDriver BurnDrvCpsProgeara= 
{ 
{"progeara" ,"Progear no Arashi (Asia 010117)","Not Working","Capcom / Cave","CPS2","2001","progear", NULL}, 
BDF_CLONE, 2, HARDWARE_CAPCOM_CPS2 | HARDWARE_CAPCOM_CPS2_SIMM, 
NULL, ProgearaRomInfo, ProgearaRomName, DrvInputInfo, NULL, 
Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan, 
&CpsRecalcPal,384,224,4,3 
}; 
