#include "cps.h"
// Quiz Nanairo Dreams

static struct BurnInputInfo DrvInputList[] =
{
  {"P1 Coin"       , BIT_DIGITAL, CpsInp020+4, "p1 coin"},
  {"P1 Start"      , BIT_DIGITAL, CpsInp020+0, "p1 start"},
  {"P1 Answer 1"   , BIT_DIGITAL, CpsInp001+4, "p1 fire 1"},
  {"P1 Answer 2"   , BIT_DIGITAL, CpsInp001+5, "p1 fire 2"},
  {"P1 Answer 3"   , BIT_DIGITAL, CpsInp001+6, "p1 fire 3"},
  {"P1 Answer 4"   , BIT_DIGITAL, CpsInp001+7, "p1 fire 4"},

  {"P2 Coin"       , BIT_DIGITAL, CpsInp020+5, "p2 coin"},
  {"P2 Start"      , BIT_DIGITAL, CpsInp020+1, "p2 start"},
  {"P2 Answer 1"   , BIT_DIGITAL, CpsInp000+4, "p2 fire 1"},
  {"P2 Answer 2"   , BIT_DIGITAL, CpsInp000+5, "p2 fire 2"},
  {"P2 Answer 3"   , BIT_DIGITAL, CpsInp000+6, "p2 fire 3"},
  {"P2 Answer 4"   , BIT_DIGITAL, CpsInp000+7, "p2 fire 4"},

  {"Reset"         , BIT_DIGITAL, &CpsReset,   "reset"},
  {"Diagnostic"    , BIT_DIGITAL, CpsInp021+1, "diag"},
  {"Service"       , BIT_DIGITAL, CpsInp021+2, "service"},
};

STDINPUTINFO(Drv);

static struct BurnRomInfo DrvRomDesc[]=
{
  {"tqzjx.03a",0x80000,0x5804a8f8, 0x10}, // xor decryption table
  {"tqzj.03a" ,0x80000,0x7acf3e30, 0x10}, // 68000 code (encrypted)
  {"tqzj.04"  ,0x80000,0xf1044a87, 0x10},
  {"tqzj.05"  ,0x80000,0x4105ba0e, 0x10},
  {"tqzj.06"  ,0x80000,0xc371e8a5, 0x10},

  // graphics:
  {"tqz.14"  ,0x200000,0x98af88a2,    1}, //  5
  {"tqz.16"  ,0x200000,0xdf82d491,    1},
  {"tqz.18"  ,0x200000,0x42f132ff,    1},
  {"tqz.20"  ,0x200000,0xb2e128a3,    1},

  // sound - z80 roms
  {"tqz.01"  ,0x020000,0xe9ce9d0a,    2}, //  9
  // sound - samples
  {"tqz.11"  ,0x200000,0x78e7884f,    2}, // 10
  {"tqz.12"  ,0x200000,0x2e049b13,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Drv) STD_ROM_FN(Drv)

struct BurnDriver BurnDrvCpsQndream=
{
  {"qndream","Quiz Nanairo Dreams: Nijiirochou no Kiseki (Japan 960826)",NULL,"Capcom","CPS2","1996",NULL, NULL},
  BDF_GAME_WORKING, 2, HARDWARE_CAPCOM_CPS2,
  NULL, DrvRomInfo, DrvRomName, DrvInputInfo, NULL,
  Cps2Init, CpsExit,Cps2Frame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
